/**
 * Die Putpat-Message-Queue zum 
 * versenden und empfangen von Events.
 * Darunter: Bauchbinde anzeigen, 
 * Kanal gewechselt, Clip gewechselt
 */
var MessageQueue = function() {
  var self = {};

  var listener = [];

  self.sendMessage = function(key, message) {
    for (var i = 0;i<listener.length;i++) {
      try {
        listener[i](key, message);
      } catch (e) {
        Putpat.debug(e.message);
      }
    }
  }

  self.addListener = function(listen) {
    if (listener.indexOf(listen) == -1) {
      try {
        listener.push(listen);
      } catch (e) {
        Putpat.debug(e.message);
      }
    }
  }

  self.removeListener = function(listen) {
    if (listener.indexOf(listen) != -1) {
      listener.splice(listener.indexOf(listen), 1);
    }
  }

  return self;
}();
