/**
 * Dies ist der Samsung Videoplayer
 */
var Player = {
    plugin : null,
    state : -1,
    stopCallback : null,
    timeCallback : null,
    originalSource : null,
    frontPanel : null,
    playTime : -1,
    safetyTimer : null,
    failCounter: 0,
    videoCounter: 0,

    x: 0,
    y: 0,
    w: 960,
    h: 540,
    resizeCalled: false,

    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,
};

Player.init = function() {
    var success = true;

    this.state = this.STOPPED;

    this.plugin = document.getElementById("pluginPlayer");
    this.frontPanel = document.getElementById("pluginFrontpanel");

    if (!this.plugin)
    {
         success = false;
    }
    else
    {
        var mwPlugin = document.getElementById("pluginObjectTVMW");

        if (!mwPlugin)
        {
            success = false;
        }

        this.plugin.OnRenderingComplete  = "Player.renderingComplete";
        this.plugin.OnCurrentPlayTime = "Player.currentPlayTime";
        this.plugin.OnRenderError = 'Player.onRenderError';
        this.plugin.OnStreamNotFound = 'Player.onStreamNotFound';
        this.plugin.OnConnectionFailed = 'Player.networkFailed';
        this.plugin.OnNetworkDisconnected = 'Player.networkFailed';
    }

    return success;
};

Player.onRenderError = function(number) {
  Putpat.debug("Render error! " + number);
};

Player.onStreamNotFound = function() {
  Putpat.debug("On stream not found!");
};

Player.networkFailed = function() {
  // Deaktiviert, da zu instabil
  // ErrorView.show("error", "ich glaube ich konnte keine Internetverbindung herstellen");
}

Player.deinit = function() {
   if (Player.plugin != null) {
      Player.plugin.Stop();
   }
   Player.plugin = null;
};

Player.setViewportBounds = function(x,y,w,h) {
    Putpat.debug("params : " + x + " - " + y + " - " +  w + " . " +  h);
    Player.x = x;
    Player.y = y;
    Player.w = w;
    Player.h = h;
    Putpat.debug("Resized params : " + Player.x + " - " + Player.y + " - " +  Player.w + " . " +  Player.h);
    Player.resizeCalled = false;
};

Player.setVideoURL = function(url) {
    Player.url = url;
    Putpat.debug("URL = " + this.url);
};

Player.playVideo = function(offset) {
  Putpat.debug("starting video");
  Player.screenSaver(false);
  if (this.url == null || this.url == undefined) {
      Putpat.debug("No videos to play");
  } else {
      clearTimeout(Player.safetyTimer);

      this.videoCounter++;

      Putpat.debug(">: " + this.url);
      this.plugin.Play( this.url );

      Player.playTime = -1;
      Player.resizeCalled = false;
      if (offset > 0) {
          this.plugin.JumpForward(offset);
      }
      this.state = this.PLAYING;

      // wenn nach ein paar Sekunden noch nix abgespielt wurde,
      // das ganze abbrechen
      var currentURL = this.url;
      Player.safetyTimer = setTimeout(function() {
        if (Player.playTime == -1) {
          if (Player.failCounter > 3) {
            Tracking.trackUrl("http://rp.putpat.tv/http_download?type=VIDEO_FAILED&random=" + (Math.floor(Math.random() * 1000)) +
                           "&client=" + CLIENT_STRING +
                           "&video_url=" + encodeURIComponent(currentURL) +
                           "&try_count=" + Player.failCounter +
                           "&play_count=" + Player.videoCounter);

            ErrorView.show("error", "Leider konnte das Video nicht abgespielt werden. Probiere es bitte später nochmal.");
          } else {
            Putpat.debug("Stoping, erhöhe Failcounter");
            Player.stopVideo(true);
            Player.failCounter++;
            Putpat.debug("fail counter für video" + Player.failCounter);

            Tracking.trackUrl("http://rp.putpat.tv/http_download?type=TIMEOUT&random=" + (Math.floor(Math.random() * 1000)) +
                           "&client=" + CLIENT_STRING +
                           "&video_url=" + encodeURIComponent(currentURL) +
                           "&try_count=" + Player.failCounter +
                           "&play_count=" + Player.videoCounter);

          }
        } else {
          Player.failCounter = 0;
        }

      }, 15000 + Player.failCounter * 5000);

      Putpat.debug("timeout set for " + (15000 + Player.failCounter * 5000))
  }
  Putpat.debug("started");
};

Player.pauseVideo = function() {
    Player.screenSaver(true);
    this.state = this.PAUSED;
    this.plugin.Pause();
};

Player.resumeVideo = function() {
    this.state = this.PLAYING;
    this.plugin.Resume();
};

Player.renderingComplete = function() {
  Putpat.debug("Rendering completed");
  Player.stopVideo(true);
};

Player.stopVideo = function(runcallback) {
    Player.screenSaver(true);
    if (this.plugin != null && this.state != this.STOPPED) {
        Putpat.debug("STOPPED!!" + this.url);
        this.state = this.STOPPED;
        this.plugin.Stop();

        if (this.stopCallback && ((runcallback == null) || !(runcallback == false))) {
          Putpat.debug("Calling stop callback");
          this.stopCallback();
        }
    }
};

Player.currentPlayTime = function(time) {
  if (Player.status != this.STOPPED) {
    Player.playTime = time;
    if (time > 0 && !Player.resizeCalled) {
        Player.resizeCalled = true;
        Player.plugin.SetDisplayArea(Player.x,Player.y,Player.w,Player.h);
    }

    if (Player.timeCallback != null) {
        Player.timeCallback(time);
    }

    var seconds = time / 1000;
    var hours = Math.floor(seconds / 3600);
    seconds -= hours * 3600;
    var minutes = Math.floor(seconds / 60);
    seconds -= minutes * 60;

    if (Player.frontPanel && Player.frontPanel.Display_VFD_Time) {
        Player.frontPanel.Display_VFD_Time(hours, minutes, seconds);
    }
  }
};

Player.skipForwardVideo = function() {
    this.plugin.JumpForward(5);
};

Player.skipBackwardVideo = function() {
    this.plugin.JumpBackward(5);
};

Player.getState = function() {
    return this.state;
};

Player.getDuration = function() {
    return this.plugin.GetDuration();
};

Player.screenSaver = function(activate) {
    try {
        if (activate) {
            pluginAPI.setOnScreenSaver();
        } else {
            pluginAPI.setOffScreenSaver();
        }
    } catch (e) {
    }
};
