/**
 * Das Channel-Overlay. Das ist
 * der Teil Oben mit dem Namen
 * des Senders
 */
var ChannelOverlay = function() {
  var self = {};

  var initialized = false;
  var logoTimer = null;
  var counter = 0;

  function messageListener(key, values) {
    if (key == "start_channel_overlay") {
      startChannelOverlay();
    } else if (key == "stop_channel_overlay") {
      stopChannelOverlay();
    } else if (key == 'new_clip') {
      if (!initialized) {
        initialized = true;
        startChannelOverlay();
      }
    }
  }

  function clearTimer() {
    if (logoTimer != null) {
      clearTimeout(logoTimer);
    }
  }

  function startChannelOverlay() {
    clearTimer();
    $("#channelOverlay").attr("src", Positions.size+"images/channelview/putpat_logo.png");
    $("#channelOverlay").show();
    logoTimer = setTimeout(hideChannelOverlay, 10000);
    counter++;
  }

  function hideChannelOverlay() {
    clearTimer();
    logoTimer = null;
    var size = Positions.screen_size[0] + "x" + Positions.screen_size[1];
    if (Putpat.playerAdvert && Putpat.playerAdvert["logomorph"] &&
        Putpat.playerAdvert["logomorph"][size] &&
        counter >= Putpat.playerAdvert["logomorph"]["show_every"]) {
        counter = 0;
        $("#channelOverlay").attr("src", Putpat.playerAdvert["logomorph"][size]["image"]);
        logoTimer = setTimeout(hideChannelLogo, Putpat.playerAdvert["logomorph"]["duration"] * 1000);
        if (Putpat.playerAdvert["logomorph"]["tracking"].length > 0) {
          Putpat.callUrls(Putpat.playerAdvert["logomorph"]["tracking"], false, false);
        }
     } else {
      hideChannelLogo();
    }
  }

  function hideChannelLogo() {
    clearTimer();
    $("#channelOverlay").hide();
    logoTimer = setTimeout(startChannelOverlay, 20000);
  }

  function stopChannelOverlay() {
    clearTimer();
    $("#channelOverlay").hide();
  }

  function showPressButton() {
    if (Settings.getValue("newUser") != false) {
      Settings.setValue("newUser", false);
      $("body").append("<img id='newUserClick' src='"+Positions.size+"images/hints/menu_hint.png'/>");
      setTimeout(function() {
        $("#newUserClick").remove();
      }, 30000);
    }
  }

  self.show = function() {
    $("body").append("<img id='channelOverlay' src='"+Positions.size+"images/channelview/putpat_logo.png'/>");
    $("#channelOverlay").hide();
    MessageQueue.addListener(messageListener);
    startChannelOverlay();
    if (Settings.getValue("newUser") != false) {
      setTimeout(showPressButton, 20000);
    }
  }

  return self;
}();
