/**
 * Der Werbehinweis über der ControlBar
 */
var PromotionOverlay = function() {
  var self = {};
  var counter = null;
  var visible = false;
  var selected = "neutral";
  var overlayClosed = false;
  var controlBarVisible = false;

  /* Hash-Funktion, erstellt einen Hash aus einem String.
   *
   * Kommt von hier:
   * http://stackoverflow.com/questions/7616461/generate-a-hash-from-string-in-javascript-jquery
   */
  function makeHash(string) {
    var hash = 0, i, char_;

    if (string.length === 0) { return hash; }

    for (i=0, l=string.length; i < l; ++i) {
      char_ = string.charCodeAt(i);
      hash = ((hash << 5) - hash) + char_;
      hash |= 0;
    }

    return hash;
  }

  function updatePosition() {
    if (controlBarVisible) {
      $("#promotionOverlay").css("bottom", Positions.promotion.with_controlbar + "px");
    } else {
      $("#promotionOverlay").css("bottom", Positions.promotion.normal + "px");
    }
  }

  function updateImage(image) {
     updatePosition();
     $("#promotionOverlay img").attr("src", getCurrentImagePath(image));
     $("#promotionOverlay").show();
  }

  function getCurrentImagePath(image) {
     var size = Positions.screen_size[0] + "x" + Positions.screen_size[1];
     return Putpat.playerAdvert["clip_promo"][size]["image_" + image];
  }

  function selectImage(img) {
    selected = img;
    updateImage(selected);
  }

  function getHashForPromoBanner() {
    if (Putpat.playerAdvert && Putpat.playerAdvert["clip_promo"]) {
      var bannerUrl = getCurrentImagePath("neutral");
      var bannerHash = makeHash(bannerUrl);

      return bannerHash;
    }

    return "";
  }

  function showOverlay() {
    counter = null;

    if (Putpat.playerAdvert && Putpat.playerAdvert["clip_promo"] && !overlayClosed) {

      var timesSeenByUser = Settings.getValue("promoVwCnt");
      if (timesSeenByUser  === null || typeof timesSeenByUser  === 'undefined') {
        // noch nie einen Banner gesehen
        timesSeenByUser = 0;
      } else {
        // der Banner wurde schonmal gesehen, weiterzählen
        timesSeenByUser = parseInt(timesSeenByUser, 10);
      }

      var lastPromoHash = Settings.getValue("promoId");
      var currentPromoHash = getHashForPromoBanner();

      if (lastPromoHash !== currentPromoHash) {
        // Neuer Banner, Counter zurücksetzen:
        timesSeenByUser = 0;
      } else {
        ++timesSeenByUser;

        // verhindern, dass der Zähler unendlich wächst:
        if (timesSeenByUser > 999) {
          timesSeenByUser = 0;
        }
      }

      Settings.setValue("promoId", currentPromoHash);
      Settings.setValue("promoVwCnt", timesSeenByUser);

      // Banner nur zeigen wenn der User ihn noch nicht x-Mal gesehen hat
      // oder wenn der Banner unbegrenzt oft gezeigt werden soll
      var maxShowPerUser = Putpat.playerAdvert["clip_promo"]["max_show_per_user"];
      if (timesSeenByUser < maxShowPerUser || maxShowPerUser === -1) {
        selectImage("neutral");
        counter = setTimeout(hideOverlay, Putpat.playerAdvert["clip_promo"]["duration"] * 1000);
        visible = true;
        if (Putpat.playerAdvert["clip_promo"]["tracking"].length > 0) {
          Putpat.callUrls(Putpat.playerAdvert["clip_promo"]["tracking"], false, false);
        }
      }

    }
  }

  function hideOverlay() {
    counter = null;
    visible = false;
    $("#promotionOverlay").hide();
    counter = setTimeout(showOverlay, Putpat.playerAdvert["clip_promo"]["pause_between"] * 1000);
  }

  function forceHide() {
    clearTimeout(counter);
    counter = null;
    $("#promotionOverlay").hide();
    visible = false;
    overlayClosed = true;
  }

  function toggleSelected() {
    if (selected == "play") {
      selectImage("close");
    } else {
      selectImage("play");
    }
  }

  function executeButton() {
    forceHide();
    ControlBar.currentScreenClosed();
    if (selected == "play") {
      ControlBar.hide();
      if (Putpat.playerAdvert["clip_promo"]["track_play"].length > 0) {
        Putpat.callUrls(Putpat.playerAdvert["clip_promo"]["track_play"], false, false);
      }
      if (Putpat.playerAdvert["clip_promo"]["playlist"] != null) {
        ChannelView.startPlaylist(Putpat.playerAdvert["clip_promo"]["playlist"]);
      } else if (Putpat.playerAdvert["clip_promo"]["channel"] != null) {
        Putpat.getChannels(function(channels) {
          selectedChannel = null;
          for (var i=0;i<channels.length;i++) {
            if (Putpat.playerAdvert["clip_promo"]["channel"] == channels[i].id) {
              selectedChannel = channels[i];
            }
          }
          if (selectedChannel != null) {
            ChannelView.switchToChannel(selectedChannel);
          }
        });
      }
    }
  }

  function keyboardHandler(event) {
     switch(event.keyCode) {
         case KEYS.KEY_LEFT:
         case KEYS.KEY_RIGHT:
             toggleSelected();
             event.preventDefault();
             break;
         case KEYS.KEY_DOWN:
             self.unFocus();
             ControlBar.currentScreenClosed();
             event.preventDefault();
             break;
         case KEYS.KEY_ENTER:
             executeButton();
             event.preventDefault();
             break;
     }
  }

  function messageListener(key, values) {
    if (key == 'disable_bauchbinde') {
      forceHide();
    } else if (key == 'enable_bauchbinde') {
      if (counter == null) {
        self.startCounter();
      }
    } else if (key == 'controlbar_visible') {
      controlBarVisible = values['visible'];
      updatePosition();
    }
  }

  self.startCounter = function() {
    if ($("#promitionOverlay").length == 0) {
      $("body").append("<div id='promotionOverlay' ><img/></div>");
    }
    var size = Positions.screen_size[0] + "x" + Positions.screen_size[1];
    if (Putpat.playerAdvert && 
        Putpat.playerAdvert["clip_promo"] && 
        Putpat.playerAdvert["clip_promo"][size] &&
        Putpat.playerAdvert["clip_promo"][size]["image_neutral"]) {
      counter = setTimeout(showOverlay, Putpat.playerAdvert["clip_promo"]["first_show"] * 1000);
    }
  };

  self.isVisible = function() {
    return visible;
  };

  self.focus = function() {
    clearTimeout(counter);
    counter = null;
    InputHandler.replaceKeyHandlers({
      keyboardHandler: keyboardHandler
    });
    selectImage("play");
  };

  self.unFocus = function() {
    selectImage("neutral");
    if (!overlayClosed) {
      counter = setTimeout(hideOverlay, Putpat.playerAdvert["clip_promo"]["duration"] * 1000);
    }
  };

  self.close = function() {
    self.unFocus();
  };

  self.hide = function() {
  };

  MessageQueue.addListener(messageListener);
  return self;
}();
