/**
 * Das Panel für die Werbung. Mit Rahmen
 * und Zähler
 */
var AdvertisementPanel = function(){
  var self = {};
  var hasClicked = false;
  var oldKeyHandlers = null;
  var adReported = 0;
  var adCount = 0;

  // Werbe-Positions-Änderungen mitbekommen
  function messageListener(key, message) {
    try {
      if (key == "advert_position") {
        reportAd(message.time, message.duration);
      }
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 19);
    }
  }

  function getTrackingFor(ad, key) {
    var result = [];

    try {
      for (var i in ad.trackings) {
        if (ad.trackings[i].key == key) {
          result.push(ad.trackings[i].url);
        }
      }
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 33);
    }

    return result;
  }

  // Checken, wie weit die Werbung schon
  // abgespielt ist und dieses dann entsprechent
  // reporten
  function reportAd(time, duration) {
    var percent = time / (duration / 100);

    if (duration > 0) {
      var number = Math.floor((duration - time) / 1000);
      if (number >= 0 && number < 180) {
        $("#counttrack").empty().append(number);
      }
    }

    var fallbackValue = "";
    try {
      if (ChannelView.currentAdvert["isFallback"]) {
        fallbackValue = "_fallback";
      }
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 58);
    }

    var urls = [];
    if (adReported < 1) {
      try {
        Tracking.trackUrl(ChannelView.currentAdvert.putpat_trackings.ad_play);

        urls.push("http://rp.putpat.tv/tracking?random=" + new Date().getTime() +"&type=AD&value=VIDEO_PLAY_STARTED"+fallbackValue+"&client=" + CLIENT_STRING);

        urls = urls.concat(getTrackingFor(ChannelView.currentAdvert, "impressions"));
        urls = urls.concat(getTrackingFor(ChannelView.currentAdvert, "survey"));
        urls = urls.concat(getTrackingFor(ChannelView.currentAdvert, "track_fullscreen"));
      } catch(e) {
        Putpat.reportError(e, "unknown", "advertisement_panel.js", 72);
      }
    } else if (percent >= 98 && adReported < 98) {
      try {
        Tracking.trackUrl(ChannelView.currentAdvert.putpat_trackings.ad_finished);

        adReported = 105;
        urls.push("http://rp.putpat.tv/tracking?random=" + new Date().getTime() +"&type=AD&value=VIDEO_PLAY_FINISHED"+fallbackValue+"&client=" + CLIENT_STRING);
        urls = urls.concat(getTrackingFor(ChannelView.currentAdvert, "track_100"));
        adCount++;
      } catch(e) {
        Putpat.reportError(e, "unknown", "advertisement_panel.js", 83);
      }
    }

    if (adReported < 98) {
      try {
        for (var i in ChannelView.currentAdvert.trackings) {
          var key = ChannelView.currentAdvert.trackings[i].key;
          var percentKey = key.match(/track_(.*)/);
          if (percentKey != null && percent >= parseInt(percentKey[1], 10) && adReported <= parseInt(percentKey[1], 10)) {
            urls = urls.concat(ChannelView.currentAdvert.trackings[i].url);
          }
        }
        if (percent > 1) {
          adReported = percent;
        } else {
          adReported = 1;
        }
      } catch(e) {
        Putpat.reportError(e, "unknown", "advertisement_panel.js", 102);
      }
    }

    try {
      for (var j in urls) {
        Tracking.trackUrl(urls[j]);
      }
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 111);
    }
  }


  function keyDown(event) {
    // Do Nothing
  }

  self.show = function(ad) {
    try {
      ChannelView.mode = "ADVERT";
      hasClicked = false;
      adReported = 0;

      $("#putpat_view").hide();

      $("body").append("<div id='advertisement'>"+
          "<img class='ad_background' src='" + Positions.size + "/images/advertisement/rahmen.png'/>"+
          "<div id='adtext'>WERBUNG</div>"+
          "<div id='adclickdiv'></div>"+
          "<div id='counterimgdiv'></div>"+
          "<div id='counttrack'></div>"+
          "<div id='nexttracks'></div>"+
          "</div>");
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 137);
    }

    try {
      ChannelView.currentClip = {
        "aspect_ratio" : (16 / 9),
        "start_offset" : 0,
        "asset_id" : null
      };

      ChannelView.currentAdvert = ad;

      oldKeyHandlers = InputHandler.replaceKeyHandlers({
        keyboardHandler: keyDown
      });

      MessageQueue.addListener(messageListener);
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 155);
    }

    try {
      $("#counterimgdiv").append("<img id='counterimg' src='"+Positions.size + "/images/advertisement/counter.png'/>");

      Player.stopVideo(false);
      Player.setVideoURL(ad.video_url);

      Player.setViewportBounds(Positions.player_advert[0],
          Positions.player_advert[1],
          Positions.player_advert[2],
          Positions.player_advert[3]);

      Player.playVideo(0);
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 171);
    }

    if (ChannelView.liveView) {
      try {
        var clip = LiveEventChannel.currentClip();
        $("#nexttracks").append("In wenigen Sekunden geht's weiter mit: "+ Utils.replaceWithHTMLEntities(clip["artist"]) + " - "+
            Utils.replaceWithHTMLEntities(clip["title"]));
      } catch(e) {
        Putpat.reportError(e, "unknown", "advertisement_panel.js", 180);
      }
    } else {
      Channels.getNextClipsForChannel(ChannelView.currentChannel, 3, function(clips) {
        try {
          var artists = "";
          for (var i in clips) {
            if (clips[i]["artist"]) {
              artists += Utils.replaceWithHTMLEntities(clips[i]["artist"]) + ", ";
            }
          }
          artists = artists.substring(0, artists.length - 2);
          $("#nexttracks").append("In wenigen Sekunden geht's weiter mit: "+ artists);
        } catch(e) {
          Putpat.reportError(e, "unknown", "advertisement_panel.js", 194);
        }
      });
    }
    MessageQueue.sendMessage("disable_bauchbinde");
  };

  self.hide = function() {
    try {
      MessageQueue.sendMessage("enable_bauchbinde");
      if (oldKeyHandlers) {
        InputHandler.replaceKeyHandlers(oldKeyHandlers);
      }
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 208);
    }

    try {
      var removedEl = $('#advertisement').remove();
      if (adReported < 98 && ChannelView.currentAdvert != null) {
        reportAd(100, 100);
      }
      Player.setViewportBounds(Positions.player_max[0],
          Positions.player_max[1],
          Positions.player_max[2],
          Positions.player_max[3]);
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 221);
    }

    try {
      MessageQueue.removeListener(messageListener);
      $("#putpat_view").show();
    } catch(e) {
      Putpat.reportError(e, "unknown", "advertisement_panel.js", 227);
    }
  };

  self.adsPlayed = function() {
    return adCount;
  };

  return self;
}();
