var RatingBar = function() {
  var self = {};

  var RATING_NAMES = [
    ["Nicht bewertet", "#909090"],
    ["Hat bei mir nichts zu suchen", "#980000"],
    ["Mittelstrahl", "#343b3e"],
    ["Geht so", "#346f88"],
    ["Der Hammer", "#2c8ab1"],
    ["Absolutes Lieblingslied", "#1b98cd"]
  ];

  var BUTTON_ROTATION = [
      'button_love_0',
      'button_love_1',
      'button_love_2',
      'button_love_3',
      'button_love_4',
      'button_close'
  ];

  var RATING_TRANSLATE = [
    0, 25, 50, 75, 100
  ];

  var selected = null;
  var currentClip = null;
  var currentRating = null;
  var sendingRating = false;

  function keyboardHandler(event) {
     var keycode = event.keyCode;

     if (sendingRating) {
       return;
     }

     switch(keycode) {
         case KEYS.KEY_LEFT:
             moveSelection(-1);
             event.preventDefault();
             break;
         case KEYS.KEY_RIGHT:
             moveSelection(+1);
             event.preventDefault();
             break;
         case KEYS.KEY_ENTER:
             executeButton();
             event.preventDefault();
             break;
         case KEYS.KEY_DOWN:
             resetButtonState();
             ControlBar.focus();
             event.preventDefault();
             break
         case KEYS.KEY_RETURN:
             self.close();
             event.preventDefault();
             break;
     }
  };

  function executeButton() {
    if (selected == "button_close") {
      self.close();
    } else {
      sendingRating = true;
        var rating = RATING_TRANSLATE[BUTTON_ROTATION.indexOf(selected)];
        updateRating({rating: rating});
        Putpat.setClipRating(currentClip, rating, function() {
          Tracking.trackAction("user_action", "rate", rating);

          setTimeout(function() {
            currentRating = null;
            self.hide();
            ControlBar.hide();
            sendingRating = false;

            if (ChannelView.currentChannel.id == 0 && rating == 0) {
                ChannelView.skipVideo();
            }
          }, 150);
        });
     }
  }

  function resetButtonState() {
    selected = null;
    $.each(BUTTON_ROTATION, function(i, button_name) {
      $("#rating_bar #"+button_name).attr("src", $("#rating_bar #"+button_name).attr('src').replace("_hover.png", ".png"));
    });
    updateRatingText(getButtonForRating(currentRating));
  }

  function selectButton(button_name) {
    resetButtonState();
    selected = button_name;
    $("#rating_bar #"+button_name).attr('src', $("#rating_bar #"+button_name).attr('src').replace(".png", "_hover.png"));

    if (BUTTON_ROTATION.indexOf(selected) < 5) {
      updateRatingText(BUTTON_ROTATION.indexOf(selected));
    } else {
      updateRatingText(getButtonForRating(currentRating));
    }
  }

  function moveSelection(dir) {
    var newitem= BUTTON_ROTATION.indexOf(selected) + dir;

    if (newitem < 0) {
      newitem = BUTTON_ROTATION.length - 1;
    } else if (newitem >= BUTTON_ROTATION.length) {
      newitem = 0;
    }

    selectButton(BUTTON_ROTATION[newitem]);
  }

  function getButtonForRating(rating) {
    var selectIcon = -1;
    if (rating != null && rating["rating"] != null) {
      if (parseFloat(rating["rating"] == 0)) {
        selectIcon = 0;
      } else {
        selectIcon = Math.ceil(parseFloat(rating["rating"]) / 25);
       }
    } else {
       selectIcon = -1;
    }

    return selectIcon;
  }

  function selectButtonForRating(rating) {
    var rButton = getButtonForRating(rating);
    if (rButton < 0) {
      rButton = 4;
    }
    selectButton("button_love_"+rButton);
  }

  function updateRating(rating) {
    currentRating = rating;

    var selectIcon = getButtonForRating(rating);

    var hateElement = $("#rating_bar #button_love_0");
    if (i == 0) {
      hateElement.attr('src', hateElement.attr('src').replace('_inactive', '_active'));
    } else {
      hateElement.attr('src', hateElement.attr('src').replace('_active', '_inactive'));
    }

    for (var i = 1;i<5;i++) {
      var element = $("#rating_bar #button_love_" + i);

      if (i <= selectIcon) {
        element.attr('src', element.attr('src').replace('_inactive', '_active'));
      } else {
        element.attr('src', element.attr('src').replace('_active', '_inactive'));
      }
    }
    updateRatingText(selectIcon);
  }

  function updateRatingText(icon) {
    $("#rating_bar #artist_rating_text").empty().append(RATING_NAMES[icon + 1][0]);
    $("#rating_bar #artist_rating_text").css("color", RATING_NAMES[icon + 1][1]);
  }

  function wireMouseEvents(button) {
    if (Device.hasMouse) {
      $("#"+button).mouseover(function() {
         ControlBar.unfocus();
         selectButton(this.id)
      });
      $("#"+button).click(function() {
        ControlBar.unfocus();
        if (selected != this.id) {
          selectButton(this.id)
        };
        executeButton(this.id);
      });
    }
  }

  self.show = function(all_graphics) {
    sendingRating = false;
    $("#rating_bar").remove();
    $("#putpat_view").append(
      "<div id='rating_bar'>" +
         "<img class='background' src='" + Positions.size + "images/rating_bar/bg_rate.jpg' />" +
         "<img id='button_close' class='artist_button' src='"+Positions.size+"images/bt_close.png'/>" +
         "<img id='button_love_0' class='artist_button' src='"+Positions.size+"images/rating_bar/bt_hate_inactive.png'/>" +
         "<img id='button_love_1' class='artist_button' src='"+Positions.size+"images/rating_bar/bt_love_inactive.png'/>" +
         "<img id='button_love_2' class='artist_button' src='"+Positions.size+"images/rating_bar/bt_love_inactive.png'/>" +
         "<img id='button_love_3' class='artist_button' src='"+Positions.size+"images/rating_bar/bt_love_inactive.png'/>" +
         "<img id='button_love_4' class='artist_button' src='"+Positions.size+"images/rating_bar/bt_love_inactive.png'/>" +
         "<div id='artist_and_title'><span class='artist_name'>"+ChannelView.currentClip["artist"]+"</span>"+
                " - <span class='title'>"+ChannelView.currentClip["title"]+"</span></div>" +
         "<div id='artist_rating_text'></div>"+
      "</div>"
    );
    ChannelView.hideChannelLogo();
    self.focus();

    wireMouseEvents("button_close");
    wireMouseEvents("button_love_0");
    wireMouseEvents("button_love_1");
    wireMouseEvents("button_love_2");
    wireMouseEvents("button_love_3");
    wireMouseEvents("button_love_4");

    if (currentClip == null || currentClip != ChannelView.currentClip["asset_id"]) {
      currentClip = ChannelView.currentClip;
      Tracking.trackAction("impression", "rate", currentClip["asset_id"]);

      Putpat.getClipRating(ChannelView.currentClip, function(rating) {
        if ($("#rating_bar").length != 0 && rating != null) {
          updateRating(rating);
          selectButtonForRating(rating);
        }
      });
    } else {
       updateRating(currentRating);
       selectButtonForRating(currenRating);
    }
  }

  self.hide = function() {
    $("#rating_bar").hide();
    $("#rating_bar img").remove();
    ChannelView.showChannelLogo();
  }

  self.close = function() {
    self.hide();
    ControlBar.currentScreenClosed();
  }

  self.focus = function() {
    InputHandler.replaceKeyHandlers({
      keyboardHandler: keyboardHandler,
    });
    selectButtonForRating(currentRating);
  }

  self.unfocus = function() {
    resetButtonState();
  }

  return self;
}();
