var TopBar = function() {
  var self = {};
  var repainting = false;

  function updateTopBar(key, message) {
    if (key == 'new_clip') {
      self.hide();
      try {
        createTopBar();
      } catch(e) {
        Putpat.debug("Error while creating topbar");
        Putpat.debug(e);
      }
    }
  }

  function createTopBar() {
    if (repainting) {
      Putpat.debug("not creating, in repaint");
      return;
    }

    repainting = true;
    var topMessage = "Gerade läuft:";

    if (ChannelView.currentClip &&
        ChannelView.currentClip.clipInfo &&
        ChannelView.currentClip.clipInfo.clip_container &&
        !Utils.isStringEmpty(ChannelView.currentClip.clipInfo.clip_container.title)) {

      topMessage = "Sendung: " + ChannelView.currentClip.clipInfo.clip_container.title;

      if (!Utils.isStringEmpty(ChannelView.currentClip.clipInfo.clip_container.claim)) {
        topMessage += " - " + ChannelView.currentClip.clipInfo.clip_container.claim;
      }
    }

    Channels.getCurrentChannelColor(function(channelColor) {
      var imageString = "";

      var size = Positions.screen_size[0] + "x" + Positions.screen_size[1];
      if (ChannelView.currentChannel == null) {
        // Nix machen, kein Kanal da :)
      } else if (Putpat.playerAdvert && // Wenn Channel-Teaser-Werbung gebucht ist, diese anzeigen
          Putpat.playerAdvert["channel_teaser"] &&
          Putpat.playerAdvert["channel_teaser"][ChannelView.currentChannel.id] &&
          Putpat.playerAdvert["channel_teaser"][ChannelView.currentChannel.id][size]["image"]) {

        imageString = "<img class='channelTeaserImage' src='"+Putpat.playerAdvert["channel_teaser"][ChannelView.currentChannel.id][size]["image"]+"'/>";
        if (Putpat.playerAdvert["channel_teaser"]["tracking"].length > 0) {
          Putpat.callUrls(Putpat.playerAdvert["channel_teaser"]["tracking"], false, false);
        }
        $("#channelShowPicture").hide();
       // Wenn Text angezegit werden soll, diesen anzeigen
      } else if (ChannelView.currentClip &&
                 ChannelView.currentClip.clipInfo &&
                 ChannelView.currentClip.clipInfo.clip_container &&
                 ChannelView.currentClip.clipInfo.clip_container.display_values == "TITLE" &&
                 !Utils.isStringEmpty(ChannelView.currentClip.clipInfo.clip_container.title)) {
         imageString = "<div class='channelTeaserText' style='color:"+channelColor+"'><table><tr><td>" +
                          Utils.replaceWithHTMLEntities(ChannelView.currentClip.clipInfo.clip_container.title) +
                      "</td></tr></table></div>";
       // Wenn eine Show gezeigt wird, das Logo dieser Show anzeigen
      } else if (ChannelView.currentClip &&
                 ChannelView.currentClip.clipInfo &&
                 ChannelView.currentClip.clipInfo.clip_container &&
                 ChannelView.currentClip.clipInfo.clip_container.display_values == "PICTURE" &&
                 !Utils.isStringEmpty(ChannelView.currentClip.clipInfo.clip_container.picture)) {
        // Do nothing, da das ganze im ChannelView in der Methode ChannelView.updateChannelShowPicture gemacht wird
        
        // Ansonsten das normale Teaser-Logo
      } else {
         imageString = "<img class='channelTeaserImage' "+
                            "src='http://files.putpat.tv/artwork/channelgraphics/"+ChannelView.currentChannel.id+"/channelteaser_" + 
                       Positions.topbar.teaser + ".png'/>";
      }

      var title = "";

      if (ChannelView.currentClip != null) {
         if (!Utils.isStringEmpty(ChannelView.currentClip.artist)) {
           title = "<div class='title' style='color:"+channelColor+"'>"+Utils.replaceWithHTMLEntities(ChannelView.currentClip.artist)+"</div>" +
                   "<div class='subtitle'>"+Utils.replaceWithHTMLEntities(ChannelView.currentClip.title)+"</div>";
         } else {
           title = "<div class='title' style='color:"+channelColor+"'>"+Utils.replaceWithHTMLEntities(ChannelView.currentClip.title)+"</div>";
         }
      }

      var removedEl = $("#topbar").remove();
      $("#putpat_view").append("<div id='topbar'>"+
                          "<div id='topbar_background'></div>"+
                          "<div class='nowrunning'>" + topMessage + "</div>"+
                          imageString +
                          title +
                     "</div>");

      repainting = false;
    });
  }

  self.show = function() {
    createTopBar();
    MessageQueue.addListener(updateTopBar);
    $("#channellogo").css("opacity", "1.0");
    Putpat.debug("done!");
  }

  self.hide = function() {
    MessageQueue.removeListener(updateTopBar);
    var removedEl = $("#topbar").remove();
    $("#channellogo").css("opacity", "0.8");
    $("#channelShowPicture").show();
  }

  return self;
}();
